# Contents

- Variable bindings
- The let keyword
- Type annotation
- Uninitialized variables
- Throwing values away
- Shadowing bindings
- Tuples
- Destructuring tuples
- Statements
- Functions
- Blocks
- Blocks are expressions
- Implicit return
- Everything is an expression
- Field access and method calling
- Modules, use syntax
- Types are namespaces too
- The libstd prelude
- Structs
- Struct update syntax
- Destructuring structs
- Patterns and destructuring
- Destructuring with if let
- Match arms are patterns
- Exhaustive matches
- Methods
- Immutability
- Traits
- Orphan rules
- The Self type
- Marker traits
- Trait method receivers
- Deriving traits
- Generics
- Generic functions
- Type parameter constraints (trait bounds)
- Monomorphization
- Generic structs
- Example: Vec
- Macros
- The panic! macro
- Functions that panic
- Enums (sum types)
- Lifetimes
- Borrowing rules (one or more immutable borrows XOR one mutable borrow)
- Functions generic over lifetimes
- Lifetime elision
- Structs generic over lifetimes
- Implementations generic over lifetimes
- The 'static lifetime
- Struct literal assignment shorthand
- Owned types vs reference types
- Slices
- Operator overloading
- Borrowing rules and slices
- String slices (&str)
- Fallible functions (Result)
- Dereferencing
- Function types, closures
- FnMut and borrowing rules
- The toilet closure
- Loops, iterators
- Returning closures
- Capturing into a closure
- Conclusion
